﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinGrid;

namespace GridKeyDownSample
{
	public partial class Form1 : Form
	{
		public Form1()
		{
			InitializeComponent();

			jOJOBindingSource.DataSource = new List<JOJO>() { new JOJO() { Name = "JOJO", HexCode = "00000000" }, new JOJO() { Name = "JAJA", HexCode = "00000000" } };
		}

		private void ultraGrid1_KeyDown(object sender, KeyEventArgs e)
		{
			UltraGridCell activeCell = ultraGrid1.ActiveCell;
			if (activeCell != null
				&& activeCell.Column.Key == "HexCode"
				&& activeCell.IsInEditMode)
			{
				if (!IsHexKey(e.KeyCode))
				{
					e.Handled = true;
				}
			}
		}

		private bool IsHexKey(Keys keys)
		{
			switch (keys)
			{
				case Keys.D0:
				case Keys.D1:
				case Keys.D2:
				case Keys.D3:
				case Keys.D4:
				case Keys.D5:
				case Keys.D6:
				case Keys.D7:
				case Keys.D8:
				case Keys.D9:
				case Keys.A:
				case Keys.B:
				case Keys.C:
				case Keys.D:
				case Keys.E:
				case Keys.F:
				case Keys.Enter:
				case Keys.Delete:
				case Keys.Back:
				case Keys.Left:
				case Keys.Right:
				case Keys.Tab:
				case Keys.Escape:
					return true;
				default:
					return false;
			}
		}
	}

	public class JOJO
	{
		public string Name { get; set; }
		public string HexCode { get; set; }

		public JOJO()
		{
		}
	}
}
